=== debian/changelog ===
falcosecurity-libs (0.1.1dev+git20220316.e5c53d64-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove empty space on control file line 65, making dkms autopkgtests fail.
    (Change committed on git, and uploaded as lowNMU policy)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 12 Feb 2023 11:23:36 +0100

falcosecurity-libs (0.1.1dev+git20220316.e5c53d64-5) unstable; urgency=medium

  * Updated Build-Depends, Testsuite for dkms (Closes: #1027872)

 -- Dima Kogan <dkogan@debian.org>  Fri, 20 Jan 2023 09:51:25 -0800

falcosecurity-libs (0.1.1dev+git20220316.e5c53d64-4) unstable; urgency=medium

  * Imported patch to build with linux kernels >= 5.18

 -- Dima Kogan <dkogan@debian.org>  Sun, 26 Jun 2022 16:40:49 -0700

falcosecurity-libs (0.1.1dev+git20220316.e5c53d64-3) unstable; urgency=medium

  * More complete fix for the FTBFS on riscv64
  * Fix FTBFS on i386

 -- Dima Kogan <dkogan@debian.org>  Tue, 14 Jun 2022 10:52:39 -0700

falcosecurity-libs (0.1.1dev+git20220316.e5c53d64-2) unstable; urgency=medium

  * Fix FTBFS on riscv64 (Closes: #991115)
    Thanks to Thorsten Alteholz <debian@alteholz.de>!
  
 -- Dima Kogan <dkogan@debian.org>  Mon, 13 Jun 2022 20:00:19 -0700

falcosecurity-libs (0.1.1dev+git20220316.e5c53d64-1) unstable; urgency=medium

  * Initial Debian release (Closes: #1011371)

 -- Dima Kogan <dkogan@debian.org>  Sat, 21 May 2022 22:11:37 -0700
